
AllocActivationInst *createAllocActivationInst(llvm::StringRef name, TypeRef Ty);

TensorViewInst *createTensorViewInst(llvm::StringRef name, Value *Src, TypeRef Ty, std::vector<dim_t> Offsets);

DeallocActivationInst *createDeallocActivationInst(llvm::StringRef name, Value *Src);

CopyInst *createCopyInst(llvm::StringRef name, Value *Dest, Value *Src);

ConvolutionGradInst *createConvolutionGradInst(llvm::StringRef name, Value *Src, Value *Filter, Value *DestGrad, Value *SrcGrad, Value *FilterGrad, Value *BiasGrad, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Group, unsigned_t Dilation, ConvolutionLayout Layout, FusedActivation FusedActivation);

ConvolutionInst *createConvolutionInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Filter, Value *Bias, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Group, unsigned_t Dilation, ConvolutionLayout Layout, FusedActivation FusedActivation);

ChannelwiseQuantizedConvolutionInst *createChannelwiseQuantizedConvolutionInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Filter, Value *Bias, Value *Scales, Value *Offsets, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Group, bool Groupwise);

Convolution3DGradInst *createConvolution3DGradInst(llvm::StringRef name, Value *Src, Value *Filter, Value *DestGrad, Value *SrcGrad, Value *FilterGrad, Value *BiasGrad, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Group);

Convolution3DInst *createConvolution3DInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Filter, Value *Bias, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Group);

MaxPoolWithArgmaxGradInst *createMaxPoolWithArgmaxGradInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Argmax, Value *DestGrad, Value *SrcGrad, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Layout);

MaxPoolWithArgmaxInst *createMaxPoolWithArgmaxInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Argmax, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Layout);

MaxPoolInst *createMaxPoolInst(llvm::StringRef name, Value *Dest, Value *Src, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Layout);

AvgPoolGradInst *createAvgPoolGradInst(llvm::StringRef name, Value *Dest, Value *Src, Value *DestGrad, Value *SrcGrad, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Layout);

AvgPoolInst *createAvgPoolInst(llvm::StringRef name, Value *Dest, Value *Src, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Layout);

ArgMaxInst *createArgMaxInst(llvm::StringRef name, Value *Argmax, Value *Input, unsigned_t Axis, bool KeepDims);

AdaptiveAvgPoolGradInst *createAdaptiveAvgPoolGradInst(llvm::StringRef name, Value *Dest, Value *DestGrad, Value *SrcGrad);

AdaptiveAvgPoolInst *createAdaptiveAvgPoolInst(llvm::StringRef name, Value *Dest, Value *Src);

FullyConnectedInst *createFullyConnectedInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Weights, Value *Bias);

RowwiseQuantizedFullyConnectedInst *createRowwiseQuantizedFullyConnectedInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Weights, Value *Bias, Value *Scales, Value *Offsets);

LocalResponseNormalizationGradInst *createLocalResponseNormalizationGradInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Scale, Value *DestGrad, Value *SrcGrad, unsigned_t HalfWindowSize, float Alpha, float Beta, float K);

LocalResponseNormalizationInst *createLocalResponseNormalizationInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Scale, unsigned_t HalfWindowSize, float Alpha, float Beta, float K);

SoftMaxInst *createSoftMaxInst(llvm::StringRef name, Value *Dest, Value *Src);

SoftMaxGradInst *createSoftMaxGradInst(llvm::StringRef name, Value *OrigDest, Value *OrigSrc, Value *Selected, Value *SrcGrad);

CrossEntropyLossInst *createCrossEntropyLossInst(llvm::StringRef name, Value *P, Value *Labels, Value *CE);

CrossEntropyLossGradInst *createCrossEntropyLossGradInst(llvm::StringRef name, Value *CEGrad, Value *P, Value *Labels, Value *Pgrad, Value *Labelsgrad);

MatMulInst *createMatMulInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

BatchMatMulInst *createBatchMatMulInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

BatchedReduceAddInst *createBatchedReduceAddInst(llvm::StringRef name, Value *Dest, Value *Batch, unsigned_t Axis);

BatchedReduceMinInst *createBatchedReduceMinInst(llvm::StringRef name, Value *Dest, Value *Batch, std::vector<unsigned_t> Axes);

LengthsSumInst *createLengthsSumInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Lengths);

SparseLengthsSumGradInst *createSparseLengthsSumGradInst(llvm::StringRef name, Value *Data, Value *Indices, Value *Lengths, Value *DestGrad, Value *DataGrad);

SparseLengthsSumInst *createSparseLengthsSumInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Indices, Value *Lengths);

SparseLengthsWeightedSumGradInst *createSparseLengthsWeightedSumGradInst(llvm::StringRef name, Value *Data, Value *Weights, Value *Indices, Value *Lengths, Value *DestGrad, Value *DataGrad, Value *WeightsGrad);

SparseLengthsWeightedSumInst *createSparseLengthsWeightedSumInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Weights, Value *Indices, Value *Lengths);

EmbeddingBagInst *createEmbeddingBagInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Weights, Value *Indices, Value *Offsets, bool HasEndOffset);

RowwiseQuantizedSparseLengthsWeightedSumInst *createRowwiseQuantizedSparseLengthsWeightedSumInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Scales, Value *Offsets, Value *Weights, Value *Indices, Value *Lengths, bool UseFP16Accumulation);

FusedRowwiseQuantizedSparseLengthsWeightedSumInst *createFusedRowwiseQuantizedSparseLengthsWeightedSumInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Weights, Value *Indices, Value *Lengths, bool UseFP16Accumulation);

EmbeddingBagByteRowwiseOffsetsInst *createEmbeddingBagByteRowwiseOffsetsInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Weights, Value *Indices, Value *Offsets, bool UseFP16Accumulation, bool HasEndOffset);

LengthsToRangesInst *createLengthsToRangesInst(llvm::StringRef name, Value *Dest, Value *Lengths);

LengthsRangeFillInst *createLengthsRangeFillInst(llvm::StringRef name, Value *Dest, Value *Lengths);

SparseToDenseInst *createSparseToDenseInst(llvm::StringRef name, Value *Dest, Value *Indices, Value *Values);

SparseToDenseMaskInst *createSparseToDenseMaskInst(llvm::StringRef name, Value *Dest, Value *Indices, Value *Values, Value *DefaultValue, Value *Lengths, std::vector<dim_t> Mask);

BatchedAddInst *createBatchedAddInst(llvm::StringRef name, Value *Dest, Value *Batch, Value *Slice);

ElementAddInst *createElementAddInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementSubInst *createElementSubInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementMulInst *createElementMulInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementDivInst *createElementDivInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementMaxInst *createElementMaxInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementMinInst *createElementMinInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementCmpLTEInst *createElementCmpLTEInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementCmpEQInst *createElementCmpEQInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementCmpLTInst *createElementCmpLTInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementIsNaNInst *createElementIsNaNInst(llvm::StringRef name, Value *Dest, Value *Src);

ElementPowInst *createElementPowInst(llvm::StringRef name, Value *Dest, Value *LHS, Value *RHS);

ElementLogInst *createElementLogInst(llvm::StringRef name, Value *Dest, Value *Src);

ElementExpInst *createElementExpInst(llvm::StringRef name, Value *Dest, Value *Src);

ElementSelectInst *createElementSelectInst(llvm::StringRef name, Value *Dest, Value *Cond, Value *LHS, Value *RHS);

ModuloInst *createModuloInst(llvm::StringRef name, Value *Dest, Value *Src, int64_t Divisor, bool SignFollowDivisor);

ReluGradInst *createReluGradInst(llvm::StringRef name, Value *Dest, Value *DestGrad, Value *SrcGrad);

ReluInst *createReluInst(llvm::StringRef name, Value *Dest, Value *Src);

SigmoidInst *createSigmoidInst(llvm::StringRef name, Value *Dest, Value *Src);

TanhInst *createTanhInst(llvm::StringRef name, Value *Dest, Value *Src);

TransposeInst *createTransposeInst(llvm::StringRef name, Value *Dest, Value *Src, std::vector<unsigned_t> Shuffle);

SplatInst *createSplatInst(llvm::StringRef name, Value *Dest, float Value);

TouchInst *createTouchInst(llvm::StringRef name, Value *Dest);

InsertTensorInst *createInsertTensorInst(llvm::StringRef name, Value *Dest, Value *Src, std::vector<dim_t> Offsets, unsigned_t Count, unsigned_t Axis);

ExtractTensorInst *createExtractTensorInst(llvm::StringRef name, Value *Dest, Value *Src, std::vector<dim_t> Offsets);

GatherInst *createGatherInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Indices, unsigned_t BatchDims);

GatherRangesInst *createGatherRangesInst(llvm::StringRef name, Value *Output, Value *Lengths, Value *Data, Value *Ranges);

ScatterDataInst *createScatterDataInst(llvm::StringRef name, Value *Data, Value *Indices, Value *Slices, bool Cumulative);

BatchOneHotInst *createBatchOneHotInst(llvm::StringRef name, Value *Dest, Value *Data, Value *Lengths, Value *Values);

SpaceToDepthInst *createSpaceToDepthInst(llvm::StringRef name, Value *Dest, Value *Src, unsigned_t BlockSize);

ResizeNearestInst *createResizeNearestInst(llvm::StringRef name, Value *Dest, Value *Src, float HeightScale, float WidthScale);

FlipInst *createFlipInst(llvm::StringRef name, Value *Dest, Value *Src, unsigned_t Axis);

DebugPrintInst *createDebugPrintInst(llvm::StringRef name, Value *Src);

TraceEventInst *createTraceEventInst(llvm::StringRef name, Value *Data, unsigned_t Index);

QuantizationProfileInst *createQuantizationProfileInst(llvm::StringRef name, Value *InputTensor, Value *Histogram, Value *ComputationInfo);

IntLookupTableInst *createIntLookupTableInst(llvm::StringRef name, Value *Dest, Value *Src, Value *Mapping);

QuantizeInst *createQuantizeInst(llvm::StringRef name, Value *Dest, Value *Src);

DequantizeInst *createDequantizeInst(llvm::StringRef name, Value *Dest, Value *Src);

RescaleQuantizedInst *createRescaleQuantizedInst(llvm::StringRef name, Value *Dest, Value *Src);

TopKInst *createTopKInst(llvm::StringRef name, Value *Values, Value *Indices, Value *Input, Value *Scratch, unsigned_t K);

ConvertToInst *createConvertToInst(llvm::StringRef name, Value *Result, Value *Input);

CPUMaxSplatInst *createCPUMaxSplatInst(llvm::StringRef name, Value *Dest, Value *Src, float SplatValue);

CPUConvDKKC8Inst *createCPUConvDKKC8Inst(llvm::StringRef name, Value *Dest, Value *Src, Value *Filter, Value *Bias, std::vector<unsigned_t> Kernels, std::vector<unsigned_t> Strides, std::vector<unsigned_t> Pads, unsigned_t Group);
